public class EratosthenesSeq {
  public static boolean[] sieve(int end) {
    final boolean[] sieve = new boolean[end + 1];

    for (int i = 2; i <= Math.sqrt(end); i++)
      if (!sieve[i])
        for (int c = i * i; c <= end; c += i)
          sieve[c] = true;

    return sieve;
  }

  public static void main(String[] args) {
    final int target = 100000000;
    final long startTime = System.currentTimeMillis();

    sieve(target);

    final long endTime = System.currentTimeMillis();
    System.out.println("Duration for interval [2, " + target + "] is "
      + (endTime - startTime) + " ms");
  }
}
